//////////////////////////////////////////////////////
//Beispiel aus Kapitel Turtlegrafik
//////////////////////////////////////////////////////


// Zustand der Turtle
float actX; // aktuelle Position
float actY;
float actW; // aktueller Winkel
color actC;  // aktuelle Farbe
boolean penIsDown; // Stift is unten (es wird gemalt)

// gloable Variablen: 
// Fenstergröße
int w=1060;
int h=1060;

// Ausgangsseitenlänge des Quadats
int laenge = 512;
int depth = 1;

///////////////////////////////////////////////////////////

void settings() {
  size(w, h);
}

void setup() {
  colorMode(HSB,360);
}

///////////////////////////////////////////////////////////

void draw() {
  background(0,0,0);
  translate(20,height-20); 
  setColor(color(0,360,360));//rot
  penDown();
  kurve(depth,laenge,90);
  noLoop();
}

///////////////////////////////////////////////////////////

void keyPressed() {
 if (key == 's') save("tmp.png");
 if (key=='+') { if (depth<10) {depth++; laenge/=2; }}
 if (key=='-') { if (depth>1 ) {depth--; laenge*=2; }}
 redraw();
}

///////////////////////////////////////////////////////////

void kurve(int tiefe,int laenge,float winkel) {
  
  // am Ende der Rekursion mache nichts mehr
  if (tiefe==0) { 
     setColor(color(0,360,360));//rot
     return;
  }
  
  turn(winkel);  
  kurve(tiefe-1,laenge,-winkel);
  
  move(laenge);
  turn(-winkel);
  kurve(tiefe-1,laenge,winkel);
  
  move(laenge);
  kurve(tiefe-1,laenge,winkel);
  turn(-winkel);  

  move(laenge);
  kurve(tiefe-1,laenge,-winkel);
  turn(winkel);  

  setColor(color(225,360,360));//blau
  
}

///////////////////////////////////////////////////////////
//
// Turtle Kommandos
//
///////////////////////////////////////////////////////////

void move(float len) {
  if (penIsDown) line(0,0,len,0);
  // bewege Turtle weiter
  translate(len,0);
}

void turn(float ang) { rotate(radians(-ang)); }
void setColor(color c) { stroke(c); }
void penUp() { penIsDown = false; }
void penDown() { penIsDown = true; }